/* (u/i)toa_fast() test with table of patterns.  Base is 2.
   Also (u/i)toa_width without expanding is tested.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

/* Compare with pattern.	*/
static int cmp (unsigned int val, int base, const char * pattern)
{
    char s[17];
    char *p;

    p = utoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = itoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = utoa_width (val, s, base, 0);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = itoa_width (val, s, base, 0);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	unsigned int val;
	int base;
	char s[17];		/* pattern	*/
    } t[] = {

	{ 0, 2,		"0" },
	{ 1, 2,		"1" },
	{ 2, 2,		"10" },
	{ 0x7fff, 2,	"111111111111111" },
	{ 0x8000, 2,	"1000000000000000" },
	{ 0x8001, 2,	"1000000000000001" },
	{ 0xfffe, 2,	"1111111111111110" },
	{ 0xffff, 2,	"1111111111111111" },
	
	/* Nonsensed flags must ignored.	*/
	{ 3, 2 | ~0xff,		"11" },
	{ -1, 2 | ~0xff,	"1111111111111111" },

    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->base, p->s))
	    exit(i);
    }
    
    return 0;
}
