/* itoa_width() test with table of patterns. Base is 10.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

#define SIZEMAX     10

/* Compare with pattern.	*/
static int cmp (int val, size_t width, const char * pattern)
{
    char s[SIZEMAX];
    char *p;
    
    p = itoa_width (val, s, 10, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	int val;
	unsigned char width;
	char s[SIZEMAX];
    } t[] = {

	{ 0, 1,		"0" },
	{ 0, 2,		" 0" },
	{ 0, 9,		"        0" },
	
	{ 1, 1,		"1" },
	{ 1, 2,		" 1" },
	{ 1, 9,		"        1" },
	
	{ -1, 1,	"-1" },
	{ -1, 2,	"-1" },
	{ -1, 3,	" -1" },
	{ -1, 9,	"       -1" },
	
	{ 32767, 4,	"32767" },
	{ 32767, 5,	"32767" },
	{ 32767, 6,	" 32767" },
	{ 32767, 9,	"    32767" },
	
	{ -32768, 5,	"-32768" },
	{ -32768, 6,	"-32768" },
	{ -32768, 7,	" -32768" },
	{ -32768, 9,	"   -32768" },

	{ 10, 2,	"10" },
	{ 10, 3,	" 10" },
	{ 100, 3,	"100" },
	{ 100, 4,	" 100" },
	{ 1000, 4,	"1000" },
	{ 1000, 5,	" 1000" },
	{ 10000, 5,	"10000" },
	{ 10000, 6,	" 10000" },

	{ -10, 3,	"-10" },
	{ -10, 4,	" -10" },
	{ -100, 4,	"-100" },
	{ -100, 5,	" -100" },
	{ -1000, 5,	"-1000" },
	{ -1000, 6,	" -1000" },
	{ -10000, 6,	"-10000" },
	{ -10000, 7,	" -10000" },
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->width, p->s))
	    exit(i);
    }
    
    return 0;
}
