/* (i/u)toa_width() test with table of patterns. Base is 2.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

#define SIZEMAX     20

/* Compare with pattern.	*/
static int
cmp (unsigned int val, size_t width, const char * pattern)
{
    char s[SIZEMAX];
    char *p;
    
    p = itoa_width (val, s, 2, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = utoa_width (val, s, 2, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	int val;
	unsigned char width;
	char s[SIZEMAX];
    } t[] = {

	{ 0, 1,		"0" },
	{ 0, 2,		"00" },
	{ 0, 19,	"0000000000000000000" },
	
	{ 1, 1,		"1" },
	{ 1, 2,		"01" },
	{ 1, 19,	"0000000000000000001" },
	
	{ -1, 15,	"1111111111111111" },
	{ -1, 16,	"1111111111111111" },
	{ -1, 17,	"01111111111111111" },
	{ -1, 19,	"0001111111111111111" },
	
	{ 2, 2,		"10" },
	{ 2, 3,		"010" },
	{ 4, 3,		"100" },
	{ 4, 4,		"0100" },
	{ 8, 4,		"1000" },
	{ 8, 5,		"01000" },
	
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->width, p->s))
	    exit(i);
    }
    
    return 0;
}
