/* ltoa_width() test with table of patterns. Base is 10.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

#define SIZEMAX     13

/* Compare with pattern.	*/
static int cmp (long val, size_t width, const char * pattern)
{
    char s[SIZEMAX];
    char *p;
    
    p = ltoa_width (val, s, 10, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	long val;
	unsigned char width;
	char s[SIZEMAX];
    } t[] = {

	{ 0, 0,		"0" },
	{ 0, 1,		"0" },
	{ 0, 2,		" 0" },
	{ 0, 12,	"           0" },
	
	{ 1, 0,		"1" },
	{ 1, 1,		"1" },
	{ 1, 2,		" 1" },
	{ 1, 12,	"           1" },
	
	{ -1, 1,	"-1" },
	{ -1, 2,	"-1" },
	{ -1, 3,	" -1" },
	{ -1, 12,	"          -1" },
	
	{ 0x7fffffff, 9,	"2147483647" },
	{ 0x7fffffff, 10,	"2147483647" },
	{ 0x7fffffff, 11,	" 2147483647" },
	
	{ 0x80000000, 10,	"-2147483648" },
	{ 0x80000000, 11,	"-2147483648" },
	{ 0x80000000, 12,	" -2147483648" },

	{ 10, 3,		" 10" },
	{ 1000, 5,		" 1000" },
	{ 100000, 7,		" 100000" },
	{ 1000000, 8,		" 1000000" },
	{ 100000000, 10,	" 100000000" },

	{ -10, 4,	" -10" },
	{ -1000, 6,	" -1000" },
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->width, p->s))
	    exit(i);
    }
    
    return 0;
}
