/* (u)ltoa_width() test with table of patterns. Base is 2.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

#define SIZEMAX     34

/* Compare with pattern.	*/
static int
cmp (unsigned long val, size_t width, const char * pattern)
{
    char s[SIZEMAX];
    char *p;
    
    p = ltoa_width (val, s, 2, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = ultoa_width (val, s, 2, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	unsigned long val;
	unsigned char width;
	char s[SIZEMAX];
    } t[] = {

	{ 0, 0,		"0" },
	{ 0, 1,		"0" },
	{ 0, 2,		"00" },
	{ 0, 33,	"000000000000000000000000000000000" },
	
	{ 1, 1,		"1" },
	{ 1, 2,		"01" },
	{ 1, 33,	"000000000000000000000000000000001" },
	
	{ -1, 32,	"11111111111111111111111111111111" },
	{ -1, 33,	"011111111111111111111111111111111" },
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->width, p->s))
	    exit(i);
    }
    
    return 0;
}
