/* Printf decimal, long.
 */
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void run (unsigned long x)
{
    char s [sizeof("4000111222")];
    unsigned char r1;
    size_t n;
    unsigned long y;
    char *p;
    
    x &= 0xffff;		/* for "test of test"	*/
    sprintf (s, "%lu", x);
    
#ifdef	TEST_OF_TEST
    (void)r1;
#else
    /* r1 ? (it is used in asm subroutine)	*/
    asm ("mov %0,r1" : "=r"(r1));
    if (r1) exit (__LINE__);
#endif

    /* strlen(s) ?	*/
    n = strlen(s);
    if (x < 10) {
	if (n != 1) exit (__LINE__);
    } else if (x < 100) {
	if (n != 2) exit (__LINE__);
    } else if (x < 1000) {
	if (n != 3) exit (__LINE__);
    } else if (x < 10000) {
	if (n != 4) exit (__LINE__);
    } else if (x < 100000) {
	if (n != 5) exit (__LINE__);
    } else if (x < 1000000) {
	if (n != 6) exit (__LINE__);
    } else if (x < 10000000) {
	if (n != 7) exit (__LINE__);
    } else if (x < 100000000) {
	if (n != 8) exit (__LINE__);
    } else if (x < 1000000000) {
	if (n != 9) exit (__LINE__);
    } else {
	if (n != 10) exit (__LINE__);
    }

    /* back ?	*/
    errno = 0;
    y = strtoul(s, & p, 10);
    if (errno || *p) exit (__LINE__);
    if (y != x) exit (__LINE__);
}

void run2 (unsigned long x)
{
    run (x);
    run (~x);
}

int main ()
{
    unsigned long x;
    int i;

    run2 (0);
    run2 (12345);
    run2 (0x5555);
    
    for (x= 1; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 3; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 7; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 0xf; x & 0xffff; x <<= 1)
	run2 (x);

    for (x= 0, i= 10; i; i--)
	run2 (x += 11111);

    for (x= 0; x <= 100; x++)
	run2 (x);
    for (x= 0xffff; x >= 0xff80; x--)
	run2 (x);

    for (i= 1; i < 10; i++) {
	run2 (i);
	run2 (10*i);
	run2 (100*i);
	run2 (1000*i);
	run2 (10000*i);
    }

    srand (8);
    for (i= 1000; i; i--)
	run2 (rand());

    return 0;
}
